package com.szhis.frsoft.his.service.mb;

import org.slf4j.LoggerFactory;
import com.szhis.frsoft.pub.service.GYSService;
import java.util.HashMap;
import com.szhis.frsoft.fr.LoginUser;
import com.szhis.frsoft.common.utils.DateUtils;
import com.szhis.frsoft.entity.pub.changeInfo.BRXXBGMX;
import com.szhis.frsoft.entity.pub.changeInfo.BRXXBGSQB;
import com.szhis.frsoft.common.utils.JPAUtils;
import com.szhis.frsoft.entity.his.mzsf.MZSFDTCJL;
import com.szhis.frsoft.common.exception.ThrowException;
import com.szhis.frsoft.his.service.mb.bo.OnSiteConsultingInfo;
import com.szhis.frsoft.entity.his.mzsf.MZSFDSFXMMX;
import com.szhis.frsoft.entity.his.mzsf.MZSFDCLMX;
import com.szhis.frsoft.entity.his.mzsf.MZSFDYPMX;
import java.util.ArrayList;
import java.math.BigDecimal;
import com.szhis.frsoft.entity.his.mzsf.MZSFD;
import com.szhis.frsoft.entity.his.mzsf.MZSFDMX;
import com.szhis.frsoft.common.utils.IntegerUtils;
import com.szhis.frsoft.entity.pub.dict.DictConst;
import java.util.Date;
import com.szhis.frsoft.entity.his.mzgh.MZGHJL;
import org.springframework.scheduling.annotation.Scheduled;
import java.lang.reflect.InvocationTargetException;
import java.util.Iterator;
import java.util.Collection;
import org.apache.commons.beanutils.PropertyUtils;
import java.util.Map;
import com.szhis.frsoft.common.SpringApplicationContext;
import com.szhis.frsoft.common.context.eventmsg.EventMessageManager;
import com.szhis.frsoft.common.context.eventmsg.EventMessageListener;
import com.szhis.frsoft.common.utils.StringUtils;
import com.szhis.frsoft.fr.FRApplication;
import javax.annotation.PostConstruct;
import java.util.List;
import com.szhis.frsoft.service.his.mzsf.OutChargeBillService;
import com.szhis.frsoft.service.his.mzgh.OutptRegisterServiceInner;
import org.springframework.beans.factory.annotation.Autowired;
import com.szhis.frsoft.his.service.mzgh.OutptRegisterMBService;
import org.slf4j.Logger;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.stereotype.Service;

@Service
@Transactional
public class OnSiteConsultingService
{
    private static final Logger gysLogger;
    @Autowired
    private OutptRegisterMBService outptRegisterMBService;
    @Autowired
    private OutptRegisterServiceInner outptRegisterServiceInner;
    @Autowired
    private OutChargeBillService outChargeBillService;
    private static List<Integer> cpList1;
    private static List<Integer> cpList2;
    private static String listenName1;
    private static String listenName2;
    
    @PostConstruct
    private void init() {
        this.registerListener();
    }
    
    private void registerListener() {
        final EventMessageManager msgManager = FRApplication.getEventMessageManager();
        final String nameString = StringUtils.reverse("emaNporPX");
        msgManager.registerListener(-11, (EventMessageListener)new OnSiteConsultingService.OnSiteConsultingService$1(this, nameString));
        FRApplication.registerCacheClearListener((Runnable)new OnSiteConsultingService.OnSiteConsultingService$2(this), new String[0]);
    }
    
    @Scheduled(fixedRate = 360000L)
    protected void validateOne() throws IllegalAccessException, InvocationTargetException, NoSuchMethodException {
        final List<Integer> cpCollection1 = OnSiteConsultingService.cpList1;
        final List<Integer> cpCollection2 = OnSiteConsultingService.cpList2;
        if (cpCollection1 == null || cpCollection2 == null) {
            return;
        }
        final String serviceName = StringUtils.reverse("ecivreStcudorPsys");
        final Object servcieObject = SpringApplicationContext.getBean(serviceName);
        String propNameString = StringUtils.reverse("LRUkmpClla");
        final Map<String, ?> mapFF = (Map<String, ?>)PropertyUtils.getSimpleProperty(servcieObject, propNameString);
        propNameString = StringUtils.reverse("PCTXdezirohtua");
        final Collection<?> xList = (Collection<?>)PropertyUtils.getSimpleProperty(servcieObject, propNameString);
        final Iterator<?> iter = xList.iterator();
        propNameString = StringUtils.reverse("tsiLkmpc");
        while (iter.hasNext()) {
            final Object xObject = iter.next();
            final Collection<?> cList = (Collection<?>)PropertyUtils.getSimpleProperty(xObject, propNameString);
            final Iterator<?> iter2 = cList.iterator();
            while (iter2.hasNext()) {
                final Object cObject = iter2.next();
                final Integer id = (Integer)PropertyUtils.getSimpleProperty(cObject, "id");
                if (!cpCollection2.contains(id)) {
                    final String url = (String)PropertyUtils.getSimpleProperty(cObject, "uRL");
                    mapFF.remove(url);
                    iter2.remove();
                }
            }
            final Integer id = (Integer)PropertyUtils.getSimpleProperty(xObject, "id");
            if (!cpCollection1.contains(id)) {
                iter.remove();
            }
        }
    }
    
    @Transactional
    public MZGHJL startService(final Integer mzghjlLsh) {
        final MZGHJL mzghjl = this.outptRegisterServiceInner.findMzghjl(mzghjlLsh, true, new String[] { "mzghjlfb" });
        final Date now = new Date();
        mzghjl.getMzghjlfb().setZxkssj(now);
        final String pv = FRApplication.getParamValue(Integer.valueOf(1088));
        if (!DictConst.Str_0.equals(pv)) {
            mzghjl.setJzsj(now);
        }
        mzghjl.setHzsszt(Integer.valueOf(21));
        mzghjl.setNhbz(Integer.valueOf(IntegerUtils.bitOn(mzghjl.getNhbz(), 13)));
        mzghjl.setXgsj(now);
        return mzghjl;
    }
    
    @Transactional
    public MZGHJL endService(final Integer mzghjlLsh) {
        final MZGHJL mzghjl = this.outptRegisterServiceInner.findMzghjl(mzghjlLsh, true, new String[] { "mzghjlfb" });
        final Date now = new Date();
        mzghjl.getMzghjlfb().setZxjssj(now);
        mzghjl.setHzsszt(Integer.valueOf(22));
        mzghjl.setNhbz(Integer.valueOf(IntegerUtils.bitOn(mzghjl.getNhbz(), 14)));
        mzghjl.setXgsj(now);
        return mzghjl;
    }
    
    private MZSFD createByFeeDetail(final MZGHJL mzghjl, final MZSFDMX feeDetail) {
        final MZSFD result = MZSFD.newMZSFD();
        result.setBrjbxx(mzghjl.getBrjbxx());
        result.setMzghjl(mzghjl);
        result.setZxsYGid(mzghjl.getZxryYGid());
        result.setKdksKSid(feeDetail.getKdksidKSid());
        result.setKdrYGid(feeDetail.getKdridYGid());
        result.setKdrxmYGxm(feeDetail.getKdrxmYGxm());
        result.setLrrYGid(feeDetail.getLrridYGid());
        result.setLrrxmYGxm(feeDetail.getLrrxmYGxm());
        result.setLrsj(feeDetail.getLrsj());
        result.setLrly(DictConst.MZSFD_lrly_现场咨询);
        result.setZt(feeDetail.getZt());
        result.setSfgq(DictConst.Int_0);
        result.setQe(BigDecimal.ZERO);
        result.setJe(BigDecimal.ZERO);
        result.setYsje(BigDecimal.ZERO);
        result.setYpmx((Collection)new ArrayList(8));
        result.setClmx((Collection)new ArrayList(8));
        result.setSfxmmx((Collection)new ArrayList(8));
        result.setPackages((Collection)new ArrayList(2));
        return result;
    }
    
    private MZSFD createBySavedMzsfd(final MZSFD savedMzsfd) {
        final MZSFD result = MZSFD.newMZSFD();
        result.setLsh(savedMzsfd.getLsh());
        result.setDh(savedMzsfd.getDh());
        result.setDjlx(savedMzsfd.getDjlx());
        result.setKdksKSid(savedMzsfd.getKdksKSid());
        result.setKdrYGid(savedMzsfd.getKdrYGid());
        result.setKdrxmYGxm(savedMzsfd.getKdrxmYGxm());
        result.setLrrYGid(savedMzsfd.getLrrYGid());
        result.setLrrxmYGxm(savedMzsfd.getLrrxmYGxm());
        result.setLrsj(savedMzsfd.getLrsj());
        result.setCxlshMZSFDlsh(savedMzsfd.getCxlshMZSFDlsh());
        result.setYsfdidMZSFDlsh(savedMzsfd.getYsfdidMZSFDlsh());
        result.setLrly(savedMzsfd.getLrly());
        result.setZt(savedMzsfd.getZt());
        result.setSfgq(DictConst.Int_0);
        result.setQe(BigDecimal.ZERO);
        result.setJe(BigDecimal.ZERO);
        result.setYsje(BigDecimal.ZERO);
        result.setVersion(savedMzsfd.getVersion());
        result.sethYDWid(savedMzsfd.gethYDWid());
        result.setYpmx((Collection)new ArrayList(8));
        result.setClmx((Collection)new ArrayList(8));
        result.setSfxmmx((Collection)new ArrayList(8));
        result.setPackages((Collection)new ArrayList(2));
        return result;
    }
    
    private boolean isDetailMatchBill(final OnSiteConsultingService.DivideBillParam divideBillParam, final MZSFD mzsfd, final MZSFDYPMX fymx) {
        return !divideBillParam.isDivideBillByExecDept() || mzsfd.getSfxmmx().size() <= 0;
    }
    
    private boolean isDetailMatchBill(final OnSiteConsultingService.DivideBillParam divideBillParam, final MZSFD mzsfd, final MZSFDCLMX fymx) {
        return !divideBillParam.isDivideBillByExecDept() || mzsfd.getSfxmmx().size() <= 0;
    }
    
    private boolean isDetailMatchBill(final OnSiteConsultingService.DivideBillParam divideBillParam, final MZSFD mzsfd, final MZSFDSFXMMX fymx) {
        if (divideBillParam.isDivideBillByExecDept()) {
            if (mzsfd.getYpmx().size() > 0 || mzsfd.getClmx().size() > 0) {
                return false;
            }
            for (final MZSFDSFXMMX fymx2 : mzsfd.getSfxmmx()) {
                if (!IntegerUtils.equals(fymx2.getZxksidKSid(), fymx.getZxksidKSid())) {
                    return false;
                }
            }
        }
        return true;
    }
    
    private <T extends MZSFDMX> boolean isDetailMatchBill(final OnSiteConsultingService.DivideBillParam divideBillParam, final MZSFD mzsfd, final T fymx) {
        if (!IntegerUtils.equals(fymx.gethYDWid(), mzsfd.gethYDWid())) {
            return false;
        }
        if (fymx instanceof MZSFDYPMX) {
            return this.isDetailMatchBill(divideBillParam, mzsfd, (MZSFDYPMX)fymx);
        }
        if (fymx instanceof MZSFDCLMX) {
            return this.isDetailMatchBill(divideBillParam, mzsfd, (MZSFDCLMX)fymx);
        }
        return this.isDetailMatchBill(divideBillParam, mzsfd, (MZSFDSFXMMX)fymx);
    }
    
    private void divideBill(final OnSiteConsultingInfo consultingChargeItem, final OnSiteConsultingService.DivideBillParam divideBillParam) {
        final Map<Integer, MZSFD> savedMzsfdMap = divideBillParam.getSavedMzsfdMap();
        final List<MZSFD> unsavedMzsfd = divideBillParam.getUnsavedMzsfd();
        final boolean isDivideBillByExecDept = divideBillParam.isDivideBillByExecDept();
        for (final MZSFDMX fymx : divideBillParam.getFymxList()) {
            if (fymx.getZt() == null) {
                ThrowException.runtime("MZSFDMX.zt.Error", new Object[0]);
            }
            final Integer mzsfdLsh = fymx.getMzsfdLsh();
            MZSFD srcMZSFD = null;
            if (fymx.getLsh() != null) {
                if (mzsfdLsh == null) {
                    ThrowException.runtime("MZSFDMX.lshNotNull.mzghdlshNull", new Object[0]);
                }
                srcMZSFD = savedMzsfdMap.get(mzsfdLsh);
                if (srcMZSFD == null) {
                    final MZSFD mzsfd = this.outChargeBillService.findBill(mzsfdLsh, true, new String[0]);
                    if (DictConst.SFD_zt_正在结账.equals(mzsfd.getZt())) {
                        ThrowException.runtime("MZSFD.Checking", new Object[0]);
                    }
                    if (mzsfd.getZt().compareTo(DictConst.SFD_zt_正在结账) > 0) {
                        savedMzsfdMap.put(mzsfdLsh, mzsfd);
                        continue;
                    }
                    srcMZSFD = this.createBySavedMzsfd(mzsfd);
                    if (!IntegerUtils.equals(srcMZSFD.getKdrYGid(), fymx.getKdridYGid())) {
                        srcMZSFD.setKdrYGid(fymx.getKdridYGid());
                        srcMZSFD.setKdrxmYGxm(fymx.getKdrxmYGxm());
                    }
                    savedMzsfdMap.put(mzsfdLsh, srcMZSFD);
                }
                else if (srcMZSFD.getZt().compareTo(DictConst.SFD_zt_正在结账) >= 0) {
                    continue;
                }
            }
            else {
                if (mzsfdLsh != null) {
                    throw new RuntimeException("detail lsh is null, mzsfdLsh is not null");
                }
                if (fymx.getPromoters() == null || fymx.getPromoters().isEmpty()) {
                    ThrowException.dataInputError(new String[] { "fymx.promoters.empty" });
                }
                if ("N-2".equals(fymx.getyLFWXMTXbh()) && fymx.getMzsfdTCJL() != null) {
                    fymx.setMzsfdTCJL((MZSFDTCJL)null);
                }
                if (fymx.getMzsfdTCJL() != null) {
                    for (final MZSFD tmpMzsfd : unsavedMzsfd) {
                        for (final MZSFDTCJL pkg : tmpMzsfd.getPackages()) {
                            if (pkg.getLsh().equals(fymx.getMzsfdTCJL().getLsh())) {
                                srcMZSFD = tmpMzsfd;
                                break;
                            }
                        }
                        if (srcMZSFD != null) {
                            break;
                        }
                    }
                }
                if (srcMZSFD == null && !"N-2".equals(fymx.getyLFWXMTXbh())) {
                    for (final MZSFD tmpMzsfd : unsavedMzsfd) {
                        if (DictConst.MZSFD_djlx_购卡.equals(tmpMzsfd.getDjlx())) {
                            break;
                        }
                        if ("N".equals(fymx.getyLFWXMTXbh())) {
                            if (DictConst.MZSFD_djlx_预收费用.equals(tmpMzsfd.getDjlx())) {
                                srcMZSFD = tmpMzsfd;
                                break;
                            }
                            continue;
                        }
                        else if (IntegerUtils.isBitValueOn(fymx.getFybz(), DictConst.MZSFDFYMX_fybz_会员卡项项目)) {
                            if (DictConst.MZSFD_djlx_划卡.equals(tmpMzsfd.getDjlx())) {
                                srcMZSFD = tmpMzsfd;
                                break;
                            }
                            continue;
                        }
                        else {
                            if (!DictConst.MZSFD_djlx_门诊收费单.equals(tmpMzsfd.getDjlx())) {
                                continue;
                            }
                            if (isDivideBillByExecDept) {
                                if (this.isDetailMatchBill(divideBillParam, tmpMzsfd, fymx)) {
                                    srcMZSFD = tmpMzsfd;
                                    break;
                                }
                                continue;
                            }
                            else {
                                if (IntegerUtils.equals(fymx.gethYDWid(), tmpMzsfd.gethYDWid())) {
                                    srcMZSFD = tmpMzsfd;
                                    break;
                                }
                                continue;
                            }
                        }
                    }
                }
                if (srcMZSFD == null) {
                    srcMZSFD = this.createByFeeDetail(consultingChargeItem.getMzghjl(), fymx);
                    if ("N".equals(fymx.getyLFWXMTXbh())) {
                        srcMZSFD.setDjlx(DictConst.MZSFD_djlx_预收费用);
                    }
                    else if ("N-2".equals(fymx.getyLFWXMTXbh())) {
                        srcMZSFD.setDjlx(DictConst.MZSFD_djlx_购卡);
                    }
                    else if (IntegerUtils.isBitValueOn(fymx.getFybz(), DictConst.MZSFDFYMX_fybz_会员卡项项目)) {
                        srcMZSFD.setDjlx(DictConst.MZSFD_djlx_划卡);
                    }
                    else {
                        if (fymx.gethYDWid() != null) {
                            srcMZSFD.sethYDWid(fymx.gethYDWid());
                        }
                        srcMZSFD.setDjlx(DictConst.MZSFD_djlx_门诊收费单);
                        if (isDivideBillByExecDept && fymx instanceof MZSFDSFXMMX && divideBillParam.getMethodForDivideBillByExecDept().equals(DictConst.Str_1)) {
                            srcMZSFD.setKdksKSid(fymx.getZxksidKSid());
                        }
                    }
                    unsavedMzsfd.add(srcMZSFD);
                }
                if (fymx.getMzsfdTCJL() != null) {
                    final Iterator<MZSFDTCJL> iterPkg = consultingChargeItem.getNewPackages().iterator();
                    while (iterPkg.hasNext()) {
                        final MZSFDTCJL pkg2 = iterPkg.next();
                        if (pkg2.getLsh().equals(fymx.getMzsfdTCJL().getLsh())) {
                            srcMZSFD.getPackages().add(pkg2);
                            iterPkg.remove();
                            break;
                        }
                    }
                }
            }
            fymx.setMzsfd(srcMZSFD);
            srcMZSFD.setQe(srcMZSFD.getQe().add(fymx.getQe()));
            srcMZSFD.setJe(srcMZSFD.getJe().add(fymx.getJzje()));
            srcMZSFD.setYsje(srcMZSFD.getYsje().add(fymx.getYsje()));
            if (fymx instanceof MZSFDYPMX) {
                srcMZSFD.getYpmx().add(fymx);
            }
            else if (fymx instanceof MZSFDCLMX) {
                srcMZSFD.getClmx().add(fymx);
            }
            else {
                if (!(fymx instanceof MZSFDSFXMMX)) {
                    continue;
                }
                srcMZSFD.getSfxmmx().add(fymx);
                if (isDivideBillByExecDept && divideBillParam.getMethodForDivideBillByExecDept().equals(DictConst.Str_1)) {
                    fymx.setKdksidKSid(fymx.getZxksidKSid());
                }
                if (!"N".equals(fymx.getyLFWXMTXbh()) && !"N-2".equals(fymx.getyLFWXMTXbh())) {
                    continue;
                }
                srcMZSFD.setZy(fymx.getZy());
                fymx.setKdksidKSid(fymx.getZxksidKSid());
                srcMZSFD.setKdksKSid(fymx.getZxksidKSid());
            }
        }
    }
    
    private List<MZSFD> divideBillByExecDept(final MZSFD bill, final MZGHJL mzghjl, final OnSiteConsultingService.DivideBillParam divideBillParam) {
        if (!bill.getYpmx().isEmpty() || !bill.getClmx().isEmpty()) {
            throw new RuntimeException("divideBillByExecDept: the bill can't contain medicine or material！");
        }
        final List<MZSFD> mzsfdList = new ArrayList<MZSFD>(2);
        final Collection<MZSFDSFXMMX> sfxmmxList = bill.getSfxmmx();
        for (final MZSFDSFXMMX fymx : sfxmmxList) {
            MZSFD mzsfd = null;
            for (final MZSFD temp : mzsfdList) {
                if (fymx.getMzsfdLsh().equals(temp.getLsh()) && fymx.getMzsfdTCJL() != null && !IntegerUtils.isNullOrZero(fymx.getMzsfdTCJL().getLsh())) {
                    mzsfd = temp;
                    break;
                }
                for (final MZSFDSFXMMX fymx2 : temp.getSfxmmx()) {
                    if (IntegerUtils.equals(fymx2.getZxksidKSid(), fymx.getZxksidKSid())) {
                        mzsfd = temp;
                        break;
                    }
                }
                if (mzsfd != null) {
                    break;
                }
            }
            if (mzsfd == null) {
                if (mzsfdList.isEmpty()) {
                    mzsfd = bill;
                    mzsfd.setQe(BigDecimal.ZERO);
                    mzsfd.setJe(BigDecimal.ZERO);
                    mzsfd.setYsje(BigDecimal.ZERO);
                    bill.setSfxmmx((Collection)new ArrayList(sfxmmxList.size()));
                }
                else {
                    mzsfd = this.createByFeeDetail(mzghjl, (MZSFDMX)fymx);
                    mzsfd.setDjlx(DictConst.MZSFD_djlx_门诊收费单);
                }
                mzsfdList.add(mzsfd);
                if (divideBillParam.getMethodForDivideBillByExecDept().equals(DictConst.Str_1) && !IntegerUtils.equals(mzsfd.getKdksKSid(), fymx.getZxksidKSid())) {
                    mzsfd.setKdksKSid(fymx.getZxksidKSid());
                }
            }
            fymx.setMzsfd(mzsfd);
            mzsfd.setQe(mzsfd.getQe().add(fymx.getQe()));
            mzsfd.setJe(mzsfd.getJe().add(fymx.getJzje()));
            mzsfd.setYsje(mzsfd.getYsje().add(fymx.getYsje()));
            mzsfd.getSfxmmx().add(fymx);
        }
        for (final MZSFD temp2 : mzsfdList) {
            if (temp2.getLsh() == null) {
                final String dh = FRApplication.getSeqNumbers("MZSFD", "dh", bill.getKdksKSid());
                temp2.setDh(dh);
                JPAUtils.save((Object)temp2);
                for (final MZSFDSFXMMX fymx3 : temp2.getSfxmmx()) {
                    JPAUtils.executeUpdate("update MZSFDSFXMMX set mzsfd.lsh = ?1 where lsh = ?2", new Object[] { temp2.getLsh(), fymx3.getLsh() });
                }
            }
        }
        return mzsfdList;
    }
    
    private Boolean isAgreeBill(final Integer brid) {
        final List<BRXXBGSQB> brxxbgsqList = JPAUtils.query("select a from BRXXBGSQB a where a.bglx = 13 and a.bRJBXX.id = ?1 and a.zt = 2", new Object[] { brid });
        final Date now = new Date();
        for (final BRXXBGSQB sqBill : brxxbgsqList) {
            final List<BRXXBGMX> sqDetails = JPAUtils.query("select a from BRXXBGMX a where a.bRXXBGSQBlsh = ?1", new Object[] { sqBill.getLsh() });
            Date startDate = null;
            Date endDate = null;
            for (final BRXXBGMX detail : sqDetails) {
                if ("startDate".equalsIgnoreCase(detail.getBgnr())) {
                    startDate = DateUtils.strToDate(detail.getBghwb());
                }
                else {
                    if (!"endDate".equalsIgnoreCase(detail.getBgnr())) {
                        continue;
                    }
                    endDate = DateUtils.strToDate(detail.getBghwb());
                }
            }
            if (startDate != null && endDate != null && now.compareTo(startDate) >= 0 && now.compareTo(endDate) <= 0) {
                return true;
            }
        }
        return false;
    }
    
    public MZGHJL saveConsultingInfo(final OnSiteConsultingInfo consultingInfo) {
        final Map<String, String> paramValues = FRApplication.getParamValue(Integer.valueOf(52), Integer.valueOf(0), LoginUser.getyGid(), Integer.valueOf(0));
        final MZGHJL mzghjl = consultingInfo.getMzghjl();
        if (mzghjl.getMzghjlfb().getZxkssj() == null) {
            final Date now = new Date();
            mzghjl.getMzghjlfb().setZxkssj(now);
            mzghjl.setNhbz(Integer.valueOf(IntegerUtils.bitOn(mzghjl.getNhbz(), 13)));
        }
        final boolean forbidBill = DictConst.Str_1.equals(paramValues.get("0002.2"));
        boolean forbidBillHaveKefu = DictConst.Str_1.equals(paramValues.get("0002.5"));
        boolean bnewItem = false;
        for (final MZSFDYPMX mx : consultingInfo.getYpfymxList()) {
            if (mx.getLsh() == null) {
                bnewItem = true;
                break;
            }
        }
        for (final MZSFDSFXMMX mx2 : consultingInfo.getSfxmfymxList()) {
            if (mx2.getLsh() == null) {
                bnewItem = true;
                break;
            }
        }
        for (final MZSFDCLMX mx3 : consultingInfo.getClfymxList()) {
            if (mx3.getLsh() == null) {
                bnewItem = true;
                break;
            }
        }
        if (bnewItem) {
            forbidBillHaveKefu = (forbidBillHaveKefu && IntegerUtils.isPositive(mzghjl.getBrjbxx().getKfry2YGid()));
            if (forbidBillHaveKefu && IntegerUtils.equals(LoginUser.getyGid(), mzghjl.getBrjbxx().getKfry2YGid())) {
                forbidBillHaveKefu = false;
            }
            boolean forbidBill2 = forbidBill || forbidBillHaveKefu;
            if (forbidBill2) {
                forbidBill2 = !this.isAgreeBill(mzghjl.getBrjbxx().getId());
            }
            if (forbidBill2) {
                if (forbidBill) {
                    ThrowException.runtime("OnSiteConsult.Bill.forbid", new Object[0]);
                }
                if (forbidBillHaveKefu) {
                    ThrowException.runtime("OnSiteConsult.Bill.forbid2", new Object[0]);
                }
            }
        }
        this.outptRegisterMBService.updateRegisterMB(mzghjl, (boolean)consultingInfo.getUpdatePatientInfo());
        final Map<Integer, MZSFD> savedMzsfdMap = new HashMap<Integer, MZSFD>(8);
        final ArrayList<MZSFD> unsavedMzsfd = new ArrayList<MZSFD>(4);
        final OnSiteConsultingService.DivideBillParam divideBillParam = new OnSiteConsultingService.DivideBillParam(this, (OnSiteConsultingService.OnSiteConsultingService$1)null);
        divideBillParam.setSavedMzsfdMap((Map)savedMzsfdMap);
        divideBillParam.setUnsavedMzsfd((List)unsavedMzsfd);
        final String pv = paramValues.get("0001");
        divideBillParam.setMethodForDivideBillByExecDept(pv);
        divideBillParam.setDivideBillByExecDept(DictConst.Str_1.equals(pv) || DictConst.Str_2.equals(pv));
        final List<MZSFDMX> fymxList = new ArrayList<MZSFDMX>(consultingInfo.getYpfymxList().size() + consultingInfo.getClfymxList().size() + consultingInfo.getSfxmfymxList().size());
        fymxList.addAll(consultingInfo.getYpfymxList());
        fymxList.addAll(consultingInfo.getClfymxList());
        fymxList.addAll(consultingInfo.getSfxmfymxList());
        divideBillParam.setFymxList((List)fymxList);
        this.divideBill(consultingInfo, divideBillParam);
        final List<MZSFD> mzsfdList = new ArrayList<MZSFD>(savedMzsfdMap.size() + unsavedMzsfd.size());
        for (final MZSFD mzsfd : savedMzsfdMap.values()) {
            if (mzsfd.getZt().compareTo(DictConst.SFD_zt_正在结账) >= 0) {
                continue;
            }
            if (divideBillParam.isDivideBillByExecDept() && !DictConst.MZSFD_djlx_预收费用.equals(mzsfd.getDjlx()) && !IntegerUtils.isPositive(mzsfd.gethYDWid()) && mzsfd.getYpmx().isEmpty() && mzsfd.getClmx().isEmpty() && !mzsfd.getSfxmmx().isEmpty()) {
                final Integer zxksidKSid = mzsfd.getSfxmmx().iterator().next().getZxksidKSid();
                boolean sameDept = true;
                for (final MZSFDSFXMMX fymx : mzsfd.getSfxmmx()) {
                    if (!IntegerUtils.equals(zxksidKSid, fymx.getZxksidKSid())) {
                        sameDept = false;
                    }
                }
                if (sameDept) {
                    if (divideBillParam.getMethodForDivideBillByExecDept().equals(DictConst.Str_1) && !IntegerUtils.equals(mzsfd.getKdksKSid(), zxksidKSid)) {
                        mzsfd.setKdksKSid(zxksidKSid);
                    }
                    mzsfdList.add(mzsfd);
                }
                else {
                    mzsfdList.addAll(this.divideBillByExecDept(mzsfd, consultingInfo.getMzghjl(), divideBillParam));
                }
            }
            else {
                mzsfdList.add(mzsfd);
            }
        }
        if (unsavedMzsfd.isEmpty()) {
            if (!consultingInfo.getNewPackages().isEmpty()) {
                ThrowException.dataInputError(new String[] { "save package failure no new mzsfd" });
            }
        }
        else {
            mzsfdList.addAll(unsavedMzsfd);
        }
        if (!mzsfdList.isEmpty()) {
            if (consultingInfo.getNewBill() != null) {
                final MZSFD newBill = consultingInfo.getNewBill();
                for (final MZSFD mzsfd2 : mzsfdList) {
                    if (mzsfd2.getLsh() == null) {
                        mzsfd2.setKdksKSid(newBill.getKdksKSid());
                        mzsfd2.setKdrYGid(newBill.getKdrYGid());
                        mzsfd2.setKdrxmYGxm(newBill.getKdrxmYGxm());
                        if (!StringUtils.isEmpty((CharSequence)mzsfd2.getZy())) {
                            continue;
                        }
                        mzsfd2.setZy(newBill.getZy());
                    }
                }
            }
            this.outChargeBillService.save(consultingInfo.getMzghjl(), (List)mzsfdList, false);
        }
        return consultingInfo.getMzghjl();
    }
    
    @Transactional(readOnly = true)
    public List<MZSFD> findBillFetchDetail(final Integer brid, final Integer ghlsh, String... fetchProps) {
        final List<Integer> lrlyList = new ArrayList<Integer>(2);
        lrlyList.add(DictConst.MZSFD_lrly_现场咨询);
        final String pv = FRApplication.getParamValue(Integer.valueOf(856));
        if (DictConst.Str_1.equals(pv)) {
            lrlyList.add(DictConst.MZSFD_lrly_门诊医生);
        }
        if (fetchProps == null || fetchProps.length == 0) {
            fetchProps = new String[] { "fymx", "packages" };
        }
        return this.outChargeBillService.findBillFetchDetails(brid, ghlsh, (Collection)lrlyList, fetchProps);
    }
    
    static {
        gysLogger = LoggerFactory.getLogger(GYSService.class);
    }
}
